Subject: Re: [GSOC PATCH v2 2/2] attr: use `repo_settings_get_attributesfile_path()` and update callers

From: Junio C Hamano <[email-masked]>
Date: Mon, 10 Mar 2025 16:08:24 -0700

Karthik Nayak <[email-masked]> writes:

> Ayush Chandekar <[email-masked]> writes:
>
>> Update attribute-related functions to retrieve the "core.attributesfile"
>> configuration via the new repository-scoped accessor
>> `repo_settings_get_attributesfile_path()`. This improves behaviour in
>> multi-repository contexts and aligns with the goal of minimizing
>> reliance on global state.
>>
>
> We should also talk about the modifications made to pass around the
> repository struct.

Yes.  We first should justify if it makes sense to cram attribute
set into the repository object and pass it around in the first
place.  Many index-state related functions do not pass repository
around because they work on index-state, so index-state is passed
around instead.  Perhaps the attribute subsystem should be the same
way, in that their globals should belong to its own abstraction that
is smaller scale than a repository object (it is permissible to have
such an attribute-set object know about which repository instance it
is related to, though).